<Cabbage>
form caption("Meter Example") size(680, 1000), guiMode("queue"), colour(2, 145, 209) pluginId("def1"), bundle ("8BitStyle.wav","8BitStyle2.wav")



soundfiler bounds(24, 76, 104, 80), channel("soundfiler1"), file("8BitStyle.wav") colour(147, 210, 0), tableBackgroundColour(0, 0, 0, 0)
button bounds(32, 166, 84, 56) corners(5), channel("play"), text("Play", "Stop")

vmeter bounds(134, 76, 15, 144) channel("vu1") value(0) outlineColour(0, 0, 0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1) 
vmeter bounds(152, 76, 15, 144) channel("vu2") value(0) outlineColour(0, 0, 0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1) 




soundfiler bounds(294, 78, 104, 80), channel("soundfiler2"), file("8BitStyle2.wav") colour(147, 210, 0), tableBackgroundColour(0, 0, 0, 0)
button bounds(306, 164, 84, 56) corners(5), channel("play2"), text("Kick", "boom") colour:0(255, 101, 0, 255) colour:1(255, 173, 0, 255)

vmeter bounds(404, 76, 15, 144) channel("vu3")  outlineColour(0, 0, 0, 255), overlayColour(0, 0, 0, 255) meterColour:0(255, 0, 255, 255) meterColour:1(0, 0, 255, 255) meterColour:2(0, 255, 255, 255) meterColour:3(0, 255, 183, 255)
vmeter bounds(422, 76, 15, 144) channel("vu4")  outlineColour(0, 0, 0, 255), overlayColour(0, 0, 0, 255) meterColour:0(255, 0, 255, 255) meterColour:1(0, 0, 255, 255) meterColour:2(0, 255, 255, 255) meterColour:3(0, 255, 183, 255)

rslider bounds(496, 196, 60, 60) range(0, 1, 0, 1, 0.001) channel("volume2") identChannel("soundfiler2")
rslider bounds(180, 186, 60, 60) channel("volume1") range(0, 1, 0, 1, 0.001)identChannel("soundfiler1")
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 16
nchnls = 2
0dbfs = 1


; Rory Walsh 2021 
;
; License: CC0 1.0 Universal
; You can copy, modify, and distribute this file, 
; even for commercial purposes, all without asking permission. 

instr 1

    SText  = "A meter widget can be used to display a audio level meter. It can accept up to three different colours to make up the level colour gradient. You need to send data to the widget from Csound in order for it to work. It does not calculate RMS values itself.\n\nIn this example, a sound file is loaded. The 'diskin2' opcode reads it back when the user hits play. The output from the file is sent to a pair of 'rms' opcodes which converts the audio signal to a k-rate rms value. A small portamento is applied to the RMS values in order to smoothen out the signal that is sent to the meter widgets."

    cabbageSet "infoText", "text", SText
    
    ;trigger playback of sample
    kPlayState, kPlayTrig cabbageGetValue "play"
    if kPlayTrig == 1 then
        if kPlayTrig == 1 then
            event "i", "SamplePlayback1", 0, 9
       
        endif
    endif   
        
endin
                
instr SamplePlayback1
   kVolume chnget "volume1"  
    SFilename = "8BitStyle.wav"
    iLen = filelen(SFilename)*sr
    kScrubber phasor 1/(iLen/sr)
    cabbageSet metro(20), "soundfiler1", "scrubberPosition", kScrubber*iLen
     a1L, a2R diskin2 SFilename, 1, 0, 1
   kVolume chnget "volume1" 
   k1 rms a1L, 20
    k2 rms a2R, 20
    
    cabbageSetValue "vu1", portk(k1*10, .25), metro(10)
    cabbageSetValue "vu2", portk(k2*10, .25), metro(10)
    
    outs a1L*kVolume, a2R*kVolume
endin
instr 2

    SText  = "A meter widget can be used to display a audio level meter. It can accept up to three different colours to make up the level colour gradient. You need to send data to the widget from Csound in order for it to work. It does not calculate RMS values itself.\n\nIn this example, a sound file is loaded. The 'diskin2' opcode reads it back when the user hits play. The output from the file is sent to a pair of 'rms' opcodes which converts the audio signal to a k-rate rms value. A small portamento is applied to the RMS values in order to smoothen out the signal that is sent to the meter widgets."

    cabbageSet "infoText", "text", SText
    
    ;trigger playback of sample
    kPlayState, kPlayTrig cabbageGetValue "play2"
    if kPlayTrig == 1 then
        if kPlayTrig == 1 then
            event "i", "SamplePlayback", 0, 0.7
       
        endif
    endif   
        
endin




instr SamplePlayback
kVolume chnget "volume2"     
    SFilename = "8BitStyle2.wav"
    iLen = filelen(SFilename)*sr
    kScrubber phasor 1/(iLen/sr)
    cabbageSet metro(20), "soundfiler2", "scrubberPosition", kScrubber*iLen
    a1L, a2R diskin2 SFilename, 1, 0, 1
    
    k1 rms a1L, 20
    k2 rms a2R, 20
    
    cabbageSetValue "vu3", portk(k1*10, .25), metro(10)
    cabbageSetValue "vu4", portk(k2*10, .25), metro(10)
    
    outs a1L*kVolume, a2R*kVolume
      
endin

</CsInstruments>
<CsScore>
 ;causes Csound to run for about 7000 years...
i1  0 z
i2  0 z
</CsScore>
</CsoundSynthesizer>
